#include <time.h>
#include <stdlib.h>
#include <string.h>
#define MAX  300
#define MID  100
#define TRUE 1
#define FALSE 0

int CopyFile(char *target,char *source); /*Ӥrɮ*/
char* PrintTime(char *language); /*CL{bɶ*/
char* SearchReplace(char *str1, const char *find, const char *replace);
int strinstr(const char *str1, const char *find);
char* strcopy(char *str1, const char *str2, int start, int length);
char* stradd(char *str1, const char *str2);

/*========================================================*/
/*str1ҦfindreplaceNAjpgO*/
char* SearchReplace(char *str1, const char *find, const char *replace) {
	char* buf, *result;
	int str_len, i, find_len;
	buf=NULL;
	result=NULL;
	find_len = strlen(find);
	while(TRUE) {
		str_len = strlen(str1);
		i = strinstr(str1, find);
	    if ( str_len <= i) {
			result = stradd(result,str1);
			free(str1);
			return result;
		}
		if (i>0) { /*O}YĤ@ӦrA~nƻser*/
			buf = strcopy(buf,str1,0,i);
			result = stradd(result,buf);
		}
		result = stradd(result,replace);
		buf = strcopy(buf,str1,i+find_len,0);
		str1 = strcopy(str1,buf,0,0);
		free(buf);
		buf=NULL;
	}
}
/*========================================================*/
/*findbstr1}lmA0}lp*/
/*pjMѫhǦ^str1*/
int strinstr(const char *str1, const char *find) {
	char *buf;

	buf = strstr(str1,find);
	if (buf!=NULL)
		return(buf - str1);
	else
		return( strlen(str1) );

}
/*========================================================*/
/*ƻsstr2strat}lA׬lengthrstr1A0}l*/
char* strcopy(char *str1, const char *str2, int start, int length) {
    char *result;
	int str2_len;
    
	str2_len = strlen(str2);

    /*ƻs<0  }lm>rסAhǦ^Ŧr*/
	if ( (length < 0) || (str2_len<=start) || (start<0) ){		
		result = (char*) malloc(1);
		*result = '\0';
		return result;
	}

    /*׬O0 ΤӤjANƻs̫*/
	if ( (length==0) || ((start + length -1) >= str2_len))
		length = str2_len-start;
    /*LpƻsT*/
	result = (char*) malloc(length+1) ;
	if (result == NULL) {
		printf("\nFunction \"strcopy\" allocate memory error!!\n");
		exit(1);
	}
	str1 = result;
	for( str2+=start ; length>0 ; length--) {
        *str1 = *str2;
		str1++;
		str2++;
	}
	*str1 = '\0';
	return result;
}
/*========================================================*/
/*str1=str1+str2 |۰ʤtO*/
char* stradd(char *str1, const char *str2) {
	char *result;

	if ( str1 != NULL ) {
		result = (char*) malloc(strlen(str1) + strlen(str2) +1);
		if (result == NULL) {
			printf("\nFunction \"stradd\" allocate memory error!!\n");
			exit(1);
		}
		strcpy(result,str1);
		strcat(result,str2);
		free(str1);
	}
	else {
		result = (char*) malloc(strlen(str2)+1);
		if (result == NULL) {
			printf("\nFunction \"stradd\" allocate memory error!!\n");
			exit(1);
		}
		strcpy(result,str2);
	}
	
	return result;
}
/*========================================================*/
char* PrintTime(char *language)
{
	char buf[MID], week[5], minites[5];
	char *str;
	struct tm *curtime;
	time_t bintime;
	time(&bintime);
	curtime = localtime(&bintime);

	if ( strcmp(language,"engish")==0 ) {
		sprintf(buf,"%s",asctime(curtime));
		str = (char *) malloc(strlen(buf)+1);
		strcpy(str,buf);
		return(str);
	}

	if (curtime->tm_wday==0)
		sprintf(week,"P");
	else if (curtime->tm_wday==1)
		sprintf(week,"P@");
	else if (curtime->tm_wday==2)
		sprintf(week,"PG");
	else if (curtime->tm_wday==3)
		sprintf(week,"PT");
	else if (curtime->tm_wday==4)
		sprintf(week,"P|");
	else if (curtime->tm_wday==5)
		sprintf(week,"P");
	else if (curtime->tm_wday==6)
		sprintf(week,"P");
	else
		sprintf(week,"");

	if ( curtime->tm_min<10)
		sprintf(minites,"0%d", curtime->tm_min);
	else
		sprintf(minites,"%d", curtime->tm_min);

	sprintf(buf,"%d~ %d %d %s %d:%s", curtime->tm_year+1900, curtime->tm_mon+1, curtime->tm_mday, week, curtime->tm_hour, minites);
	str = (char *) malloc(strlen(buf)+1);
	strcpy(str,buf);
	return(str);
}

/*========================================================*/
int CopyFile(char *target,char *source) {
	FILE *fp1, *fp2;
	char string1[MAX];

	if ( (fp1 = fopen( target, "w+")) == NULL) {
		printf("\nOpen file error!! There is no \"%s\" for writing.\n",target);
		return(1);
	}
	if ( (fp2 = fopen( source, "r")) == NULL) {
		printf("\nOpen file error!! There is no \"%s\" for reading.\n",source);
		return(1);
	}

	while ( fgets(string1,MAX,fp2) != NULL ) {
		fputs(string1,fp1);
		strcpy(string1,"");
	}
	fclose (fp1);
	fclose (fp2);
	return(0);
}
/*========================================================*/

